/*
 * AT&T's public domain getopt().
 *
 * This was FTPed from comp.sources.unix archives, vol 3 (Feb '86)
 *    as att_getopt.c. These archives can be found on UUNET.UU.NET.
 *
 * Code modified to support ANSI function prototypes, GAT, 29-Oct-89.
 *
 * Modifications to provide prototypes for all functions, GAT, 27-Jul-90.
 */

/*LINTLIBRARY*/
#define NULL   0
#define EOF    (-1)
#define ERR(s, c)    if(opterr){\
   extern int strlen(char *), write(int, char *, unsigned int);\
   char errbuf[2];\
   errbuf[0] = c; errbuf[1] = '\n';\
   (void) write(2, argv[0], (unsigned)strlen(argv[0]));\
   (void) write(2, s, (unsigned)strlen(s));\
   (void) write(2, errbuf, 2);}

extern int strcmp(char *, char *);
extern char *strchr(char *, int);

int   opterr = 1;
int   optind = 1;
int   optopt;
char  *optarg;

int getopt(int argc, char **argv, char *opts)
{
   static int sp = 1;
   register int c;
   register char *cp;

   if(sp == 1)
      if(optind >= argc ||
            argv[optind][0] != '-' || argv[optind][1] == '\0')
         return(EOF);
      else if(strcmp(argv[optind], "--") == NULL) {
         optind++;
         return(EOF);
      }
   optopt = c = argv[optind][sp];
   if(c == ':' || (cp=strchr(opts, c)) == NULL) {
      ERR(": illegal option -- ", c);
      if(argv[optind][++sp] == '\0') {
         optind++;
         sp = 1;
      }
      return('?');
   }
   if(*++cp == ':') {
      if(argv[optind][sp+1] != '\0')
         optarg = &argv[optind++][sp+1];
      else if(++optind >= argc) {
         ERR(": option requires an argument -- ", c);
         sp = 1;
         return('?');
      } else
         optarg = argv[optind++];
      sp = 1;
   } else {
      if(argv[optind][++sp] == '\0') {
         sp = 1;
         optind++;
      }
      optarg = NULL;
   }
   return(c);
}
